sc::IntCoor Class Referenceabstract

    The IntCoor abstract class describes an internal coordinate of a

molecule. More...

`#include <coor.h>`

Inheritance diagram for sc::IntCoor:
[legend]
Collaboration diagram for sc::IntCoor:
[legend]

## Public Member Functions

| IntCoor (StateIn &)
| IntCoor (const IntCoor &)
| IntCoor (const char *label=0)
| This constructor takes a string containing a label for the internal coordinate. More...
| IntCoor (const Ref< KeyVal > &)
| The KeyVal constructor. More...
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
virtual const char * | label () const
| Returns the string containing the label for the internal coordinate.
virtual double | value () const
| Returns the value of the coordinate in atomic units or radians.
virtual void | set_value (double)
| Sets the value of the coordinate in atomic units or radians.
virtual double | preferred_value () const
| Returns the value of the coordinate in more familiar units.
virtual const char * | ctype () const =0
| Returns a string representation of the type of coordinate this is.
virtual void | print (std::ostream &o=ExEnv::out0()) const
| Print information about the coordinate.
virtual void | print_details (const Ref< Molecule > &, std::ostream &=ExEnv::out0()) const
virtual double | force_constant (Ref< Molecule > &)=0
| Returns the value of the force constant associated with this coordinate. More...
virtual void | update_value (const Ref< Molecule > &)=0
| Recalculate the value of the coordinate.
virtual void | bmat (const Ref< Molecule > &, RefSCVector &bmat, double coef=1.0)=0
| Fill in a row the the B matrix.
virtual int | equivalent (Ref< IntCoor > &)=0
| Test to see if this internal coordinate is equivalent to that one. More...
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Attributes

char * | label_
double | value_

## Static Protected Attributes

static double | bohr_conv
static double | radian_conv

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

    The IntCoor abstract class describes an internal coordinate of a

molecule.

## Constructor & Destructor Documentation

sc::IntCoor::IntCoor | ( | const char * | label = `0` | ) |

This constructor takes a string containing a label for the internal coordinate.

The string is copied.

sc::IntCoor::IntCoor | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor.

`label`

  A label for the coordinate using only to identify the coordinate to the user in printouts. The default is no label.

`value`

  A value for the coordinate. In the way that coordinates are usually used, the default is to compute a value from the cartesian coordinates in a Molecule object.

`unit`

  The unit in which the value is given. This can be bohr, anstrom, radian, and degree. The default is bohr for lengths and radian for angles.

## Member Function Documentation

virtual int sc::IntCoor::equivalent | ( | Ref< IntCoor > & |  | ) |

pure virtual

Test to see if this internal coordinate is equivalent to that one.

The definition of equivalence is left up to the individual coordinates.

Implemented in sc::SumIntCoor, and sc::SimpleCo.

virtual double sc::IntCoor::force_constant | ( | Ref< Molecule > & |  | ) |

pure virtual

Returns the value of the force constant associated with this coordinate.

Implemented in sc::SumIntCoor, and sc::SimpleCo.

void sc::IntCoor::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

Reimplemented in sc::SumIntCoor, and sc::SimpleCo.

The documentation for this class was generated from the following file:

- coor.h